VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-------------------------------------------
' Main Class:                              '
' Started on: 6/9/2006                     '
' Version: 1.0.50                          '
'-------------------------------------------
'-         Writed By Alience               -
'-------------------------------------------

Option Explicit
Dim DAORS As DAO.Recordset
Dim DAODB As DAO.Database
Dim MDBSTRING As String

Private Sub Class_Initialize()
 On Local Error Resume Next
 
 MDBSTRING = ""
End Sub

Private Sub Class_Terminate()
 On Local Error Resume Next
 
 Set DAODB = Nothing
 Set DAORS = Nothing
 If Err.Number <> 0 Then Err.Clear
End Sub

Public Function Records(GetText As String) As String
 On Local Error GoTo ErrHandler
 
 Dim ParsedText() As String, ParsedText2() As String
 Dim FieldName As String, FieldNameInt As Integer

 Select Case True
 
        Case LCase(GetText) Like "field(*)"
           ParsedText() = Split(GetText, "(")
           If IsNumeric(Left(ParsedText(1), Len(ParsedText(1)) - 1)) Then
             FieldNameInt = Left(ParsedText(1), Len(ParsedText(1)) - 1)
             Records = DAORS.Fields(FieldNameInt)
           Else
             FieldName = Left(ParsedText(1), Len(ParsedText(1)) - 1)
             Records = DAORS.Fields(FieldName)
           End If
           
        Case LCase(GetText) = "movelast" Or LCase(GetText) = "last"
             DAORS.MoveLast
             Records = Round(((DAORS.RecordCount * DAORS.PercentPosition) / 100) + 1)
        
        Case LCase(GetText) = "movefirst" Or LCase(GetText) = "first"
             DAORS.MoveFirst
             Records = Round(((DAORS.RecordCount * DAORS.PercentPosition) / 100) + 1)
        
        Case LCase(GetText) = "movenext" Or LCase(GetText) = "next"
             DAORS.MoveNext
             Records = Round(((DAORS.RecordCount * DAORS.PercentPosition) / 100) + 1)
        
        Case LCase(GetText) = "moveprevious" Or LCase(GetText) = "previous" Or LCase(GetText) = "prev"
             DAORS.MovePrevious
             Records = Round(((DAORS.RecordCount * DAORS.PercentPosition) / 100) + 1)
        
        Case LCase(GetText) = "recordcount" Or LCase(GetText) = "count"
             Records = DAORS.RecordCount
        
        Case LCase(GetText) Like "field(*).name"
           ParsedText() = Split(GetText, "(")
           If IsNumeric(Left(ParsedText(1), Len(ParsedText(1)) - 6)) Then
             FieldNameInt = Left(ParsedText(1), Len(ParsedText(1)) - 6)
             Records = DAORS.Fields(FieldNameInt).Name
           Else
             FieldName = Left(ParsedText(1), Len(ParsedText(1)) - 6)
             Records = DAORS.Fields(FieldName).Name
           End If
        
        Case LCase(GetText) Like "field(*).getpart *"
           ParsedText2() = Split(GetText, " ")
           If UBound(ParsedText2) < 2 Then
             Records = -1
           End If
           ParsedText() = Split(ParsedText2(0), "(")
           If IsNumeric(Left(ParsedText(1), Len(ParsedText(1)) - 9)) Then
             FieldNameInt = Left(ParsedText(1), Len(ParsedText(1)) - 9)
             Records = Mid(Str(DAORS.Fields(FieldNameInt)), ParsedText2(1), ParsedText2(2))
           Else
             FieldName = Left(ParsedText(1), Len(ParsedText(1)) - 9)
             Records = Mid(DAORS.Fields(FieldName), ParsedText2(1), ParsedText2(2))
           End If
        
        Case LCase(GetText) Like "field(*).len"
           ParsedText() = Split(GetText, "(")
           If IsNumeric(Left(ParsedText(1), Len(ParsedText(1)) - 5)) Then
             FieldNameInt = Left(ParsedText(1), Len(ParsedText(1)) - 5)
             Records = Len(DAORS.Fields(FieldNameInt))
           Else
             FieldName = Left(ParsedText(1), Len(ParsedText(1)) - 5)
             Records = Len(DAORS.Fields(FieldName))
           End If
        
        Case LCase(GetText) = "fields count"
             Records = DAORS.Fields.Count
        
        Case LCase(GetText) = "bookmark" Or LCase(GetText) = "pos"
             Records = Round(((DAORS.RecordCount * DAORS.PercentPosition) / 100) + 1)
        
        Case Else
             Records = DispError("Unknown", "Unknown Function " & GetText)
 End Select
 
Exit Function
ErrHandler:
 Records = DispError(Err.Number, Err.Description)
End Function

Public Function Tables(GetText As String) As String
 On Local Error GoTo ErrHandler
 
 Dim ParsedText() As String, FieldName As String, FieldNameInt As Integer
 Select Case True
        Case LCase(GetText) Like "table(*)"
           ParsedText() = Split(GetText, "(")
           If IsNumeric(Left(ParsedText(1), Len(ParsedText(1)) - 1)) Then
             FieldNameInt = Left(ParsedText(1), Len(ParsedText(1)) - 1)
             Tables = DAODB.TableDefs(FieldNameInt).Name
           Else
             FieldName = Left(ParsedText(1), Len(ParsedText(1)) - 1)
             Tables = DAODB.TableDefs(FieldName).Name
           End If
        Case LCase(GetText) = "count"
             Tables = DAODB.TableDefs.Count
        Case Else
             Tables = DispError("Unknown", "Unknown Function " & GetText)
 End Select
Exit Function
ErrHandler:
 Tables = DispError(Err.Number, Err.Description)
End Function

Public Function SQL(GetText As String) As String
 On Local Error GoTo ErrHandler

 If MDBSTRING <> "" Then
    GetText = Replace(GetText, "MdbStr", MDBSTRING)
    GetText = Replace(GetText, "mdbstr", MDBSTRING)
 End If
 
 Set DAORS = Nothing
 
 If InStr(1, LCase(GetText), "select") Then
   Set DAORS = DAODB.OpenRecordset(GetText)
   DAORS.MoveLast: DAORS.MoveFirst
   SQL = DAORS.RecordCount
 Else
   DAODB.Execute (GetText)
   SQL = 1
 End If

Exit Function
ErrHandler:
 SQL = DispError(Err.Number, Err.Description)
End Function

Public Function OpenDB(DBpath As String) As String
 On Local Error GoTo ErrHandler

 Set DAODB = DAO.OpenDatabase(DBpath)
 OpenDB = DBpath
Exit Function
ErrHandler:
 OpenDB = DispError(Err.Number, Err.Description)
End Function

Public Function CreateDB(DBpath As String) As String
 On Local Error GoTo ErrHandler

 Set DAODB = DAO.CreateDatabase(DBpath, dbLangGeneral)
 CreateDB = DBpath
Exit Function
ErrHandler:
 CreateDB = DispError(Err.Number, Err.Description)
End Function

Public Function MdbStr(GetStr As String) As String
 On Local Error GoTo ErrHandler
 
 Dim ParsedText() As String, i As Integer
 Select Case True
        Case LCase(GetStr) = "clear"
           MDBSTRING = ""
           MdbStr = 1
        Case LCase(GetStr) Like "add *"
             ParsedText() = Split(GetStr, " ")
             If UBound(ParsedText) < 1 Then
               MdbStr = -1
             End If
             For i = 1 To UBound(ParsedText)
               MDBSTRING = MDBSTRING & " " & ParsedText(i)
             Next i
             Trim (MDBSTRING)
             MdbStr = 1
        Case Else
             MdbStr = DispError("Unknown", "Unknown Function " & GetStr)
 End Select
Exit Function
ErrHandler:
 MdbStr = DispError(Err.Number, Err.Description)
End Function

Public Function About() As String
 On Local Error GoTo ErrHandler
 
 MsgBox "MircDB allows you send sql using Microsoft DAO object library.", vbInformation Or vbOKOnly, "MircDB About!"
 Exit Function
ErrHandler:
 About = DispError(Err.Number, Err.Description)
End Function

Public Function Version() As String
 On Local Error GoTo ErrHandler
 
 MsgBox "MircDB" & vbCrLf & "Version: 1.0.50" & vbCrLf & "Codded by Alience", vbInformation Or vbOKOnly, "MircDB Version!"
 Exit Function
ErrHandler:
 Version = DispError(Err.Number, Err.Description)
End Function

Private Function DispError(ErrNo As String, ErrDesc As String) As String
 On Local Error Resume Next
 
 DispError = "Error: " & ErrNo & " Description: " & ErrDesc
 Err.Clear
End Function

