;eer MircDB isid olarak arlrsa dll den gelen deeri dner
;rnek olarak /MircDB opendb dbname hibir deer dnmezken
;//echo $MircDB(opendb,dbname) dbname deeri olarak dner
alias MircDB {
  if !$com(MircDB) { 
    .comopen MircDB MircDB.Main
    if ($comerr) {
      .comreg $qt($+($scriptdir,MircDB.dll))
      .comopen MircDB MircDB.Main
      if ($comerr) halt
    }
  }
  if $1 == Close { .comclose MircDB }
  else {
    var %k = $com(MircDB,$1,3,bstr,$2-)
    if $isid { return $com(MircDB).result }
  }
}


alias example_1 {

  ;database varm? varsa sil :D
  if $exists(example.mdb) { MircDB Close | .remove example.mdb  }

  ;mirc dizininde example.mdb yi oluturalm, oluturma fonksiyonu ayn zamanda OpenDB fonksiyonunun iinide yapar o yzden amamza gerek yok
  echo $MircDB(CreateDB,example.mdb)

  ;ExampleTable tablomuz databasemizde varm (paranoyaklk mod on :P, hem silip hemde kontrol ettirmek olsun bu rnek nasl olduunu grn :D)
  if Error: 3265 isin $MircDB(Tables,table(ExampleTable)) {

    ;eer 1 deeri dnerse tablo oluturulmutur
    echo $iif($MircDB(SQL,CREATE TABLE ExampleTable) == 1,ExampleTable Created,$v1)
  }

  ;eer Error: 3066 erroru dnerse ExampleTable de hibir filed yok demektir
  if Error: 3066 isin $MircDB(SQL,SELECT * FROM ExampleTable) {
    ;eer 1 deeri dnerse ExampleField oluturulmutur
    echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleField Integer) == 1,ExampleField [Integer] Created,$v1)
  }
  else { 
    ;example field varm yoksa olutur
    if Error: 3265 isin $MircDB(Records,field(ExampleField).name) {
      echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleField Integer) == 1,ExampleField [Integer] Created,$v1)
    }
  }

  ;ExampleField'e 1 den 250 ye kadar integer deerler ile dolduralm
  var %i = 1
  while %i <= 250 {
    MircDB sql Insert INTO ExampleTable (ExampleField) VALUES (' $+ %i $+ ')
    inc %i 1
  }
  MircDb Close
  echo ExampleField dolduruldu. /example_2 yi deneyin.
}


alias example_2 {
  ;databaseyi aalm
  echo $MircDB(OpenDB,example.mdb)

  ;ExamapleField alan database de varm
  MircDB SQL SELECT * FROM ExampleTable
  if Error: 3265 isin $MircDB(Records,field(ExampleField).name) { echo ExampleField alan database de yok. Oluturmak iin ltfen /example_1 kullann | halt }
  ;max 10 recordu seelim
  var %Number_of_Records =  $MircDB(SQL,SELECT TOP 10  ExampleField FROM ExampleTable ORDER BY ExampleField DESC)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else {
    echo MAX 10 kayt:
    var %i = 1
    while %i <= %Number_of_Records {
      echo $+(%i,:) $MircDB(Records,field(0))
      ;br sonraki kayda gidelim
      MircDB Records next
      inc %i 1
    }
  }

  ;lets select less 10 records
  var %Number_of_Records =  $MircDB(SQL,SELECT TOP 10  ExampleField FROM ExampleTable ORDER BY ExampleField ASC)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else {
    echo EN AZ 10 kayt:
    var %i = 1
    while %i <= %Number_of_Records {
      echo $+(%i,:) $MircDB(Records,field(0))
      ;bir sonraki kayda idelim
      MircDB Records next
      inc %i 1
    }
  }

  ;kaytlarn avarajn alalm
  var %Number_of_Records = $MircDB(SQL,SELECT AVG(ExampleField) FROM ExampleTable)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else { echo Kaytlarn avaraj: $MircDB(Records,field(0)) }
  MircDB Close
  echo Example 2 bitti, /example_3  deneyin.
}



alias example_3 {
  ;$exists kullanmadan example.mdb varm bakalm :D
  if Error: 3024 !isin $MircDB(OpenDB,example.mdb) {
    echo $v2
  }
  else { echo example.mdb yok ltfe /example_1 i kullanp oluturalm. | halt }

  ;herhangi bir tablo varm
  if Error: 3066 !isin $MircDB(SQL,SELECT * FROM ExampleTable) { 

    ;ExampleField varm
    if Error: 3265 !isin $MircDB(Records,field(ExampleField).name) {
      ;varsa sl gitsin iimize yaramaz imdilik :D
      echo : $MircDB(SQL,ALTER TABLE ExampleTable DROP ExampleField)
    }
  }
  ;mirc yaklak 900 karaktere kadar izin verir bizim databasede 900 karakterden daha fazla karakter yazmak istersek!
  ;MdbStr fonksiyonunu kullanalm bakalm %')

  ;MdbStr yi temizleyelim
  echo : $MircDB(MdbStr,Clear)

  ;899 tane x ve bir tanede boluk karekterini Mdbstr ye ekleyelim
  echo $iif($MircDB(MdbStr,ADD $str(x,899) $+ $chr(32)) == 1,899 tane x eklendi,$v1)

  ;899 tane y ve bir tanede boluk karekterini Mdbstr ye ekleyelim
  echo $iif($MircDB(MdbStr,ADD $str(y,899) $+ $chr(32)) == 1,899 tane y eklendi,$v1)

  ;899 tane z ve bir tanede boluk karekterini Mdbstr ye ekleyelim
  echo $iif($MircDB(MdbStr,ADD $str(z,899) $+ $chr(32)) == 1,899 tane z eklendi,$v1) 

  ;imdi MdbStr mizi database ekleyelim ilk nce
  ;Bir Memo field oluturalm ki byk apta data alabilsin bu field.

  ;daha nce SQL sorgusu gnderdiimiz iin Records u kullanabiliriz eer ExampleMemoField yoksa oluturalm
  if Error isin $MircDB(Records,field(ExampleMemoField).name) {
    echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleMemoField Memo) == 1,ExampleField [Integer] Created,$v1)
  }
  ;MdbStr yi nne nickimi ekleyerek database e ekleyelim :D
  echo $iif($MircDB(sql,INSERT INTO ExampleTable (ExampleMemoField) VALUES ('Alience MdbStr')) == 1,Total Data added,$v1)

  ;Mirc 900 karaktere felan izin veriyor yazmtk imdi kaydetiimiz yazy okumak iin
  ;Records field().getpart balama boyut fonksiyonunu kullanalm
  ;ama nce o kayd sememiz lazm. seelim
  echo $iif(Error !isin $MircDB(sql,SELECT * FROM ExampleTable WHERE ExampleMemoField = 'Alience MdbStr'),Added Data Selected,$v1)

  ;Setiimiz kaydn boyutu nekadar
  echo Kaydn boyutu: $MircDB(Records,field(ExampleMemoField).len)

  ;Benim nicki alalm
  echo $MircDB(Records,field(ExampleMemoField).getpart 1 7)

  ;899 tane x i alalm
  echo $MircDB(Records,field(ExampleMemoField).getpart 8 899)

  MircDB Close
}
